Package com.ads.services.webservice

# Class CodesetManagerService

java.lang.Object
com.ads.services.webservice.CodesetManagerService

public class CodesetManagerService extends Object
The Simple Object Access Protocol or SOAP is a protocol for sending and receiving messages between applications
Web Services are based on the SOAP protocol.The response can be either JSON or XML.
Contains the methods related to perform the operations such as creation, update, deletion and retrieval of Categories, Codesets, Code Mappings, Code Values etc.
All the WebServices methods have return type String - meaning if the method is execution is successful, then it will return a string in the form of JSON or XML String based on the outputFormat parameter given by the user.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CodesetManagerService()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `addCodeValue(String userName, String password, String outputFormat, String codeValue, boolean saveExtendedProperties)`
  Codevalue is added for the specified codeValue object and also extended properties are added only if the saveExtendedProperties flag is true.
  `String`
  `addCodeValues(String userName, String password, String outputFormat, String codeValues, boolean saveExtendedProperties)`
  Codevalues are added for the specified codeValue objects and also extended properties are added only if the saveExtendedProperties flag is true.
  `String`
  `assignCodeset(String userName, String password, String outputFormat, String nodeType, int nodeId, String codeset)`
  Assigns the specified codeset object to the specified nodeType and nodeId.
  `String`
  `assignCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId, String codesetIds, boolean unassignExisting)`
  Assigns codesets of specified codeset ids to the specified nodeType and nodeId.
  `String`
  `cloneCodeset(String userName, String password, String outputFormat, int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists)`
  Codeset is cloned for the given srcCodesetId to the given tgtCategoryId.
  `String`
  `createCategories(String userName, String password, String outputFormat, String categories)`
  Categories are added for the specified list of category objects.
  `String`
  `createCategory(String userName, String password, String outputFormat, String category)`
  Category is added for the specified category object.
  `String`
  `createCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)`
  Category is added for the specified categoryName and categoryType.
  `String`
  `createCodeset(String userName, String password, String outputFormat, String codeset, boolean saveCodeValues)`
  Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true.
  `String`
  `createCodesets(String userName, String password, String outputFormat, String codesets, boolean saveCodeValues)`
  Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true.
  `String`
  `createCSMEnvironment(String userName, String password, String outputFormat, String csmEnvironment)`
  Environment is added for the specified environment object.
  `String`
  `createCSMEnvironments(String userName, String password, String outputFormat, String csmEnvironments)`
  List of environments are added for the specified list of environment objects.
  `String`
  `deleteCategories(String userName, String password, String outputFormat, String categoryIds, String categoryType)`
  Deletes the categories with the specified list of categoryIds and categoryType.
  `String`
  `deleteCategory(String userName, String password, String outputFormat, int categoryId, String categoryType)`
  Deletes the category with the specified categoryId and categoryType.
  `String`
  `deleteCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)`
  Deletes the category with the specified categoryName and categoryType.
  `String`
  `deleteCodeset(String userName, String password, String outputFormat, int codesetId, String versionMode)`
  Deletes the codeset with the specified codesetId and versionMode.
  `String`
  `deleteCodesets(String userName, String password, String outputFormat, String codesetIds, String versionMode)`
  Deletes the codesets with the specified codesetIds list and versionMode.
  `String`
  `deleteCodesetsByCategory(String userName, String password, String outputFormat, int categoryId, String versionMode)`
  Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets.
  `String`
  `deleteCodesetsByNames(String userName, String password, String outputFormat, int categoryId, String codesetNames, String versionMode)`
  Deletes the list of codesets for the specified categoryId, codesetNames and versionMode.
  `String`
  `deleteCodeValue(String userName, String password, String outputFormat, int codeValueId, String deleteMode)`
  Deletes the codevalue with the specified codeValueId and deleteMode.
  `String`
  `deleteCodeValues(String userName, String password, String outputFormat, String codeValueIds, String deleteMode)`
  Deletes the list of codevalue objects with the specified codeValueIds list and deleteMode.
  `String`
  `deleteCodeValuesByCodeset(String userName, String password, String outputFormat, int codesetId, String deleteMode)`
  Deletes the list of codevalue objects with the specified codesetId and deleteMode.
  `String`
  `deleteCSMEnvironment(String userName, String password, String outputFormat, int environmentId)`
  Deletes the environment with the specified environmentId.
  `String`
  `deleteCSMEnvironmentByName(String userName, String password, String outputFormat, String environmentName)`
  Deletes the environment with the specified environmentName.
  `String`
  `deleteCSMEnvironments(String userName, String password, String outputFormat, String environmentIds)`
  Deletes the environments with the specified list of environmentIds.
  `String`
  `exportAllCodesets(String userName, String password, String outputFormat)`
  All the codesets present in enterprise codesets are exported to excel.
  `String`
  `exportCodesets(String userName, String password, String outputFormat, int categoryId, boolean includeSubCategories)`
  Codesets are exported to excel for the specified categoryId.
  `String`
  `exportCodeValues(String userName, String password, String outputFormat, int codesetId)`
  Codevalues are exported to excel for the specified codesetId.
  `String`
  `getAllRetiredCodesets(String userName, String password, String outputFormat)`
  Returns the list of all retired codesets present in enterprise codesets.
  `String`
  `getAssignedCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId, int fillOptions)`
  Returns the list of codeset objects for the specified nodeType and nodeId.
  `String`
  `getCategories(String userName, String password, String outputFormat, String categoryIds, String categoryType, int fillOptions)`
  Returns the list of category objects for the specified categoryIds list and categoryType.Specifying the categoryIds list and categoryType are mandatory.
  `String`
  `getCategory(String userName, String password, String outputFormat, int categoryId, String categoryType, int fillOptions)`
  Returns the category object for the specified categoryId and categoryType.
  `String`
  `getCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)`
  Returns the category object for the specified parentCategoryId, categoryType and categoryName.
  `String`
  `getCategoryId(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)`
  Returns the category id for the specified categoryName and categoryType.
  `String`
  `getCodeset(String userName, String password, String outputFormat, int codesetId, int fillOptions)`
  Returns the codeset object for the specified codesetId.
  `String`
  `getCodesetByName(String userName, String password, String outputFormat, int categoryId, String codesetName, int fillOptions)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `String`
  `getCodesetByVersion(String userName, String password, String outputFormat, int categoryId, String codesetName, float version, int fillOptions)`
  Returns the codeset object for the specified categoryId, codesetName and version.
  `String`
  `getCodesetId(String userName, String password, String outputFormat, int categoryId, String codesetName)`
  Returns the codeset id for the specified categoryId and codesetName.
  `String`
  `getCodesets(String userName, String password, String outputFormat, int categoryId, int fillOptions)`
  Returns the list of codeset objects for the specified categoryId.
  `String`
  `getCodesetsByIds(String userName, String password, String outputFormat, String codesetIds, int fillOptions)`
  Returns the list of codeset objects for the specified codesetIds list.
  `String`
  `getCodeValues(String userName, String password, String outputFormat, int categoryId, String codesetName, int fillOptions)`
  Returns the list of codevalue objects for the specified categoryId and codesetName.
  `String`
  `getCodeValuesByCodeset(String userName, String password, String outputFormat, int codesetId, int fillOptions)`
  Returns the list of codevalue objects for the specified codesetId.
  `String`
  `getCSMEnvironment(String userName, String password, String outputFormat, int environmentId)`
  Returns the environment object for the specified environmentId.
  `String`
  `getCSMEnvironmentId(String userName, String password, String outputFormat, String environmentName)`
  Returns the environment id for the specified environmentName.
  `String`
  `getCSMEnvironmentName(String userName, String password, String outputFormat, int environmentId)`
  Returns the environmen name for the specified environmentId.
  `String`
  `getCSMEnvironments(String userName, String password, String outputFormat)`
  Returns the list of environments along with all the details regarding each environment.
  `String`
  `getLogicallyDeletedCodeValues(String userName, String password, String outputFormat, int codesetId)`
  Returns the list of retired codevalue objects for the specified codesetId.
  `String`
  `getPublishedCodesets(String userName, String password, String outputFormat, int environmentId)`
  Returns the list of published codesets for the specified environmentId.
  `String`
  `getRetiredCodesets(String userName, String password, String outputFormat, int categoryId)`
  Returns the list of retired codeset objects for the specified categoryId.
  `String`
  `getValidValues(String userName, String password, String outputFormat, String nodeType, int nodeId, int fillOptions)`
  Returns the list of codeValue objects for the specified nodeType and nodeId.
  `String`
  `importCodesets(String userName, String password, String outputFormat, int categoryId, String importHelper)`
  Imports the codesets on the specified categoryId.
  `String`
  `importCodeValues(String userName, String password, String outputFormat, int codesetId, String importHelper)`
  Imports the codevalues on the specified codesetId.
  `String`
  `publishCodeset(String userName, String password, String outputFormat, String codeset)`
  Codeset is published for the specified codeset object.
  `String`
  `publishCodesets(String userName, String password, String outputFormat, String codesets)`
  Codesets are published for the specified list of codeset objects.
  `String`
  `restoreCodeValues(String userName, String password, String outputFormat, String codeValueIds)`
  Retired codevalues can be restored for the specified codeValueIds.
  `String`
  `retireCodeset(String userName, String password, String outputFormat, int codesetId)`
  Codeset is retired for the given codesetId.
  `String`
  `retireCodesets(String userName, String password, String outputFormat, String codesetIds)`
  Codesets are retired for the given list of codesetIds.
  `String`
  `unassignExistingCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId)`
  Unassigns existing codesets for the specified nodeType of nodeId.
  `String`
  `unpublishCodeset(String userName, String password, String outputFormat, int codesetId)`
  Codeset is unpublished for the specified codesetId.
  `String`
  `unpublishCodesets(String userName, String password, String outputFormat, String codesetIds)`
  Codesets are unpublished for the specified list of codesetIds.
  `String`
  `updateCategories(String userName, String password, String outputFormat, String categories)`
  Categories are updated with the specified category objects.
  `String`
  `updateCategory(String userName, String password, String outputFormat, String category)`
  Category is updated with the specified category object.
  `String`
  `updateCodeset(String userName, String password, String outputFormat, String codeset)`
  Updates the codeset with the specified codeset object.
  `String`
  `updateCodesets(String userName, String password, String outputFormat, String codesets)`
  Updates the codesets with the specified codeset objects list.
  `String`
  `updateCodeValue(String userName, String password, String outputFormat, String codeValueObjJson, boolean updateExtendedProperties)`
  Updates codevalue for the codeId specified in the codevalue object and also updates its extended properties only if the updateExtendedProperties flag is true.
  `String`
  `updateCodeValues(String userName, String password, String outputFormat, String codeValuesObjJsonArray, boolean updateExtendedProperties)`
  Updates list of codevalues for the codeId specified in the each codevalue object and also updates its corresponding extended properties only if the updateExtendedProperties flag is true.
  `String`
  `updateCSMEnvironment(String userName, String password, String outputFormat, String csmEnvironment)`
  Updates the environment with the specified environment object.
  `String`
  `versionCodeset(String userName, String password, String outputFormat, String codeset)`
  Codeset is versioned for the specified codeset object.
  `String`
  `versionCodesets(String userName, String password, String outputFormat, String codesets)`
  Codesets are versioned for the specified list of codeset objects.Creates a copy of entire codeset with new codeset id and passive state.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CodesetManagerService

    public CodesetManagerService()

- ## Method Details

  - ### updateCodeValue

    public String updateCodeValue(String userName, String password, String outputFormat, String codeValueObjJson, boolean updateExtendedProperties)
    Updates codevalue for the codeId specified in the codevalue object and also updates its extended properties only if the updateExtendedProperties flag is true. Specification of codeId in the codevalue object and updateExtendedProperties flag are mandatory.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValueObjJson` - String
      `updateExtendedProperties` - boolean
    Returns:
      String - If codevalue is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValueObjJson' JSON :
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }

    Since:
      8.2.1

  - ### updateCodeValues

    public String updateCodeValues(String userName, String password, String outputFormat, String codeValuesObjJsonArray, boolean updateExtendedProperties)
    Updates list of codevalues for the codeId specified in the each codevalue object and also updates its corresponding extended properties only if the updateExtendedProperties flag is true.
    Specification of codeId in the each codevalue object and updateExtendedProperties flag are mandatory.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValuesObjJsonArray` - String
      `updateExtendedProperties` - boolean
    Returns:
      String - If codevalues are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValuesObjJsonArray' JSON :
      [
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      },
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }
      ]

    Since:
      8.2.1

  - ### createCategory

    public String createCategory(String userName, String password, String outputFormat, String category)
    Category is added for the specified category object. Specifying the category name and category type are mandatory, while creating the category. To create a sub category specifying the parent category id is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `category` - String JSON
    Returns:
      String - If category is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Category' JSON :
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }

    Since:
      12.0

  - ### createCategoryByName

    public String createCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)
    Category is added for the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory, while creating the category. To create a sub category specifying the parentCategoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
    Returns:
      String - If category is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### createCategories

    public String createCategories(String userName, String password, String outputFormat, String categories)
    Categories are added for the specified list of category objects. Specifying the category name and category type in each category object are mandatory, while creating the categories. To create a sub category specifying the parent category id is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categories` - String JsonArray
    Returns:
      String - If categories are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Categories' JsonArray :
      [
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      },
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }
      ]

    Since:
      12.0

  - ### updateCategory

    public String updateCategory(String userName, String password, String outputFormat, String category)
    Category is updated with the specified category object. All the information pertaining to the category can be updated. Specifying the category id, category name and category type are mandatory to update the category.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `category` - String JSON
    Returns:
      String - If category is updated successfully, it will return RequestStatus Object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Category' JSON :
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }

    Since:
      12.0

  - ### updateCategories

    public String updateCategories(String userName, String password, String outputFormat, String categories)
    Categories are updated with the specified category objects. All the information pertaining to the categories can be updated. Specifying the category id, category name and category type in each category object are mandatory to update the categories.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categories` - String JsonArray
    Returns:
      String - If categories are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Categories' JsonArray :
      [
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      },
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }
      ]

    Since:
      12.0

  - ### deleteCategory

    public String deleteCategory(String userName, String password, String outputFormat, int categoryId, String categoryType)
    Deletes the category with the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory to delete a particular category.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
    Returns:
      String - If category is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCategoryByName

    public String deleteCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)
    Deletes the category with the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory to delete a particular category. To delete a sub category specifying the parentCategoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `parentCategoryId` - int
      `categoryType` - String
      `categoryName` - String
    Returns:
      String - If category is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCategories

    public String deleteCategories(String userName, String password, String outputFormat, String categoryIds, String categoryType)
    Deletes the categories with the specified list of categoryIds and categoryType. Specifying the categoryIds list and categoryType are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryIds` - String
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
    Returns:
      String - If categories are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategory

    public String getCategory(String userName, String password, String outputFormat, int categoryId, String categoryType, int fillOptions)
    Returns the category object for the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory. If you want to return the category object filled with codeset and codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - Category object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategoryByName

    public String getCategoryByName(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)
    Returns the category object for the specified parentCategoryId, categoryType and categoryName. Specifying the parentCategoryId, categoryType and categoryName are mandatory.
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
    Returns:
      String - Category object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategories

    public String getCategories(String userName, String password, String outputFormat, String categoryIds, String categoryType, int fillOptions)
    Returns the list of category objects for the specified categoryIds list and categoryType.Specifying the categoryIds list and categoryType are mandatory. If you want to return the category object filled with codeset and codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like categoryName, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryIds` - String
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of category objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategoryId

    public String getCategoryId(String userName, String password, String outputFormat, int parentCategoryId, String categoryType, String categoryName)
    Returns the category id for the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory. Specifying the parentCategoryId is mandatory to return sub category id.
    It returns the category id.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
    Returns:
      String - categoryId in the form of JSON or XML String.
    Since:
      12.0

  - ### createCodeset

    public String createCodeset(String userName, String password, String outputFormat, String codeset, boolean saveCodeValues)
    Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true. Specifying the codeset name, category id and saveCodeValues flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeset` - String JSON
      `saveCodeValues` - boolean
    Returns:
      String - If codeset is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }

    Since:
      12.0

  - ### createCodesets

    public String createCodesets(String userName, String password, String outputFormat, String codesets, boolean saveCodeValues)
    Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true. Specifying the codeset name, category id in each codevalue object and saveCodeValues flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesets` - String JsonArray
      `saveCodeValues` - boolean
    Returns:
      String - If codesets are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      },
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### updateCodeset

    public String updateCodeset(String userName, String password, String outputFormat, String codeset)
    Updates the codeset with the specified codeset object. All the information related to the codeset can be updated. Specifying the codeset id, codeset name and category id are mandatory to update the codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeset` - String JSON
    Returns:
      String - If codeset is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }

    Since:
      12.0

  - ### updateCodesets

    public String updateCodesets(String userName, String password, String outputFormat, String codesets)
    Updates the codesets with the specified codeset objects list. All the information pertaining to the codesets can be updated. Specification of codeset id, codeset name and category id in each codeset object are mandatory to update the codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesets` - String JsonArray
    Returns:
      String - If codesets are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### deleteCodeset

    public String deleteCodeset(String userName, String password, String outputFormat, int codesetId, String versionMode)
    Deletes the codeset with the specified codesetId and versionMode. Specifying the codesetId is mandatory to delete a particular codeset. If versionMode is not specified current version codeset will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codeset is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      String - If codeset is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String
    Since:
      12.0

  - ### deleteCodesets

    public String deleteCodesets(String userName, String password, String outputFormat, String codesetIds, String versionMode)
    Deletes the codesets with the specified codesetIds list and versionMode. Specifying the codesetIds list is mandatory. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetIds` - String
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String
    Since:
      12.0

  - ### deleteCodesetsByCategory

    public String deleteCodesetsByCategory(String userName, String password, String outputFormat, int categoryId, String versionMode)
    Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String
    Since:
      12.0

  - ### deleteCodesetsByNames

    public String deleteCodesetsByNames(String userName, String password, String outputFormat, int categoryId, String codesetNames, String versionMode)
    Deletes the list of codesets for the specified categoryId, codesetNames and versionMode. Specifying the categoryId and codesetNames are mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `codesetNames` - String
      `versionMode` - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String
    Since:
      12.0

  - ### getCodeset

    public String getCodeset(String userName, String password, String outputFormat, int codesetId, int fillOptions)
    Returns the codeset object for the specified codesetId. Specifying the codesetId is mandatory. If you want to return the codeset object filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetByName

    public String getCodesetByName(String userName, String password, String outputFormat, int categoryId, String codesetName, int fillOptions)
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. If you want to return the codeset object filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetByVersion

    public String getCodesetByVersion(String userName, String password, String outputFormat, int categoryId, String codesetName, float version, int fillOptions)
    Returns the codeset object for the specified categoryId, codesetName and version. Specifying the categoryId, codesetName and version are mandatory. Active/Passive codeset based on version will be returned in this method. If you want to return the codeset object filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `codesetName` - String
      `version` - float
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetId

    public String getCodesetId(String userName, String password, String outputFormat, int categoryId, String codesetName)
    Returns the codeset id for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Only active version codeset id will be returned in this method.
    It returns codeset id.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `codesetName` - String
    Returns:
      String - codeset id in the form of JSON or XML String..
    Since:
      12.0

  - ### getCodesets

    public String getCodesets(String userName, String password, String outputFormat, int categoryId, int fillOptions)
    Returns the list of codeset objects for the specified categoryId. Specifying the categoryId is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML.
      `categoryId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of codeset objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetsByIds

    public String getCodesetsByIds(String userName, String password, String outputFormat, String codesetIds, int fillOptions)
    Returns the list of codeset objects for the specified codesetIds list. Specifying the codesetIds list is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetIds` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of codeset objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getPublishedCodesets

    public String getPublishedCodesets(String userName, String password, String outputFormat, int environmentId)
    Returns the list of published codesets for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentId` - int
    Returns:
      String - List of published codeset objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getRetiredCodesets

    public String getRetiredCodesets(String userName, String password, String outputFormat, int categoryId)
    Returns the list of retired codeset objects for the specified categoryId. Specifying the categoryId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
    Returns:
      String - List of retired codeset objects in the form of JSON or XML String.
    Since:
      12.0

  - ### publishCodeset

    public String publishCodeset(String userName, String password, String outputFormat, String codeset)
    Codeset is published for the specified codeset object. Specifying the codeset id, change description and publish environments list are mandatory to publish codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeset` - String JSON
    Returns:
      String - If codeset is published successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }

    Since:
      12.0

  - ### publishCodesets

    public String publishCodesets(String userName, String password, String outputFormat, String codesets)
    Codesets are published for the specified list of codeset objects. Specification of codeset id, change description and publish environments list in each codeset object are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesets` - String JsonArray
    Returns:
      String - If codesets are published successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### unpublishCodeset

    public String unpublishCodeset(String userName, String password, String outputFormat, int codesetId)
    Codeset is unpublished for the specified codesetId. Specifying the codesetId is mandatory to unPublish codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
    Returns:
      String - If codeset is unpublished successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### unpublishCodesets

    public String unpublishCodesets(String userName, String password, String outputFormat, String codesetIds)
    Codesets are unpublished for the specified list of codesetIds. Specifying the list of codesetIds is mandatory to unPublish codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetIds` - String
    Returns:
      String - If codesets are unpublished successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### retireCodeset

    public String retireCodeset(String userName, String password, String outputFormat, int codesetId)
    Codeset is retired for the given codesetId. Specifying the codesetId is mandatory. Retired codesets cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
    Returns:
      String - If codeset is retired successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### retireCodesets

    public String retireCodesets(String userName, String password, String outputFormat, String codesetIds)
    Codesets are retired for the given list of codesetIds. specifying the list of codesetIds is mandatory. Retired codesets cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetIds` - String
    Returns:
      String - If codesets are retired successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### versionCodeset

    public String versionCodeset(String userName, String password, String outputFormat, String codeset)
    Codeset is versioned for the specified codeset object. Creates a copy of entire codeset with new codeset id and passive state. Specifying the codeset id, change description are mandatory to version codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeset` - String
    Returns:
      If codeset is versioned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }

    Since:
      12.0

  - ### versionCodesets

    public String versionCodesets(String userName, String password, String outputFormat, String codesets)
    Codesets are versioned for the specified list of codeset objects.Creates a copy of entire codeset with new codeset id and passive state. Specification of codeset id and change description in each codeset object are mandatory to version the codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesets` - String JsonArray
    Returns:
      If codesets are versioned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### cloneCodeset

    public String cloneCodeset(String userName, String password, String outputFormat, int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists)
    Codeset is cloned for the given srcCodesetId to the given tgtCategoryId. Specifying the srcCodesetId and tgtCategoryId are mandatory to clone the Codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcCodesetId` - int
      `createNewVersionIfExists` - boolean
      `tgtCategoryId` - int
    Returns:
      If codeset is cloned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### createCSMEnvironment

    public String createCSMEnvironment(String userName, String password, String outputFormat, String csmEnvironment)
    Environment is added for the specified environment object. Specifying the environment name is mandatory, while creating the environment.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `csmEnvironment` - String JSON
    Returns:
      String - If environment is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Environment' JSON :
      {
      "name": "",
      "auditHistory": null
      }

    Since:
      12.0

  - ### createCSMEnvironments

    public String createCSMEnvironments(String userName, String password, String outputFormat, String csmEnvironments)
    List of environments are added for the specified list of environment objects. Specifying the environment name is mandatory, while creating the environments.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `csmEnvironments` - String JsonArray
    Returns:
      String - If environments are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Environments' JsonArray :
      [
      {
      "name": "",
      "auditHistory": null
      },
      {
      "name": "",
      "auditHistory": null
      }
      ]

    Since:
      12.0

  - ### updateCSMEnvironment

    public String updateCSMEnvironment(String userName, String password, String outputFormat, String csmEnvironment)
    Updates the environment with the specified environment object. All the information pertaining to the environment can be updated. Specifying the environment id is mandatory to update the environment.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `csmEnvironment` - String JSON
    Returns:
      String - If environment is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Environment' JSON :
      {
      "id": 0,
      "name": "",
      "auditHistory": null
      }

    Since:
      12.0

  - ### getCSMEnvironmentId

    public String getCSMEnvironmentId(String userName, String password, String outputFormat, String environmentName)
    Returns the environment id for the specified environmentName. Specifying the environmentName is mandatory.
    It returns the environment id
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentName` - String
    Returns:
      String - environment id in the form of JSON or XML String.
    Since:
      12.0

  - ### getCSMEnvironmentName

    public String getCSMEnvironmentName(String userName, String password, String outputFormat, int environmentId)
    Returns the environmen name for the specified environmentId. Specifying the environmentId is mandatory.
    It returns the environment name
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentId` - int
    Returns:
      String - environment name in the form of JSON or XML String
    Since:
      12.0

  - ### getCSMEnvironment

    public String getCSMEnvironment(String userName, String password, String outputFormat, int environmentId)
    Returns the environment object for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like environment name, id, description, auditHistory details etc.. etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentId` - int
    Returns:
      String - Environment object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCSMEnvironments

    public String getCSMEnvironments(String userName, String password, String outputFormat)
    Returns the list of environments along with all the details regarding each environment.
    Returns all the available environments as a list of environment Objects.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Environment objects in the form of JSON or XML String
    Since:
      12.0

  - ### deleteCSMEnvironment

    public String deleteCSMEnvironment(String userName, String password, String outputFormat, int environmentId)
    Deletes the environment with the specified environmentId. Specifying the environmentId is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentId` - int
    Returns:
      String - If environment is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCSMEnvironmentByName

    public String deleteCSMEnvironmentByName(String userName, String password, String outputFormat, String environmentName)
    Deletes the environment with the specified environmentName. Specifying the environmentName is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentName` - String
    Returns:
      String - If environment is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCSMEnvironments

    public String deleteCSMEnvironments(String userName, String password, String outputFormat, String environmentIds)
    Deletes the environments with the specified list of environmentIds. Specifying the environmentIds list is mandatory.
    If the environments are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `environmentIds` - String
    Returns:
      String - If environments are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### addCodeValue

    public String addCodeValue(String userName, String password, String outputFormat, String codeValue, boolean saveExtendedProperties)
    Codevalue is added for the specified codeValue object and also extended properties are added only if the saveExtendedProperties flag is true. Specifying the codeset id, code name, value and saveExtendedProperties flag are mandatory, while creating the codevalue.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValue` - String JSON
      `saveExtendedProperties` - boolean
    Returns:
      String - If codevalue is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValueObj' JSON :
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }

    Since:
      12.0

  - ### addCodeValues

    public String addCodeValues(String userName, String password, String outputFormat, String codeValues, boolean saveExtendedProperties)
    Codevalues are added for the specified codeValue objects and also extended properties are added only if the saveExtendedProperties flag is true. Specification of codeset id, code name, value in each codevalue object and saveExtendedProperties flag are mandatory, while creating the codevalues.
    If codeValues are not required then pass 0(zero) which is default value for fillOptions
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValues` - String JSON
      `saveExtendedProperties` - boolean
    Returns:
      String - If codevalues are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValuesObjJson' JSON :
      [
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      },
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }
      ]

    Since:
      12.0

  - ### getCodeValues

    public String getCodeValues(String userName, String password, String outputFormat, int categoryId, String codesetName, int fillOptions)
    Returns the list of codevalue objects for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If codeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of codevalue objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodeValuesByCodeset

    public String getCodeValuesByCodeset(String userName, String password, String outputFormat, int codesetId, int fillOptions)
    Returns the list of codevalue objects for the specified codesetId. Specifying the codesetId is mandatory. Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If codeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of codevalue objects in the form of JSON or XML String
    Since:
      12.0

  - ### deleteCodeValue

    public String deleteCodeValue(String userName, String password, String outputFormat, int codeValueId, String deleteMode)
    Deletes the codevalue with the specified codeValueId and deleteMode. Specifying the codeValueId is mandatory. If deleteMode is not specified the codevalue object will be purge deleted. Retired code values can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValueId` - int
      `deleteMode` - String - Valid values are RETIRE/PURGE.
    Returns:
      String - If codevalue is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodeValues

    public String deleteCodeValues(String userName, String password, String outputFormat, String codeValueIds, String deleteMode)
    Deletes the list of codevalue objects with the specified codeValueIds list and deleteMode. Specifying the codeValueIds list is mandatory. If deleteMode is not specified the codevalue objects will be purge deleted. Retired code values can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If codevalues are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValueIds` - String
      `deleteMode` - String - Valid values are RETIRE/PURGE.
    Returns:
      String - If codevalues are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodeValuesByCodeset

    public String deleteCodeValuesByCodeset(String userName, String password, String outputFormat, int codesetId, String deleteMode)
    Deletes the list of codevalue objects with the specified codesetId and deleteMode. Specifying the codesetId is mandatory to delete codevalues. If deleteMode is not specified the codevalue objects will be purge deleted. Retired code values can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete cannot be restored.
    If codevalues are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
      `deleteMode` - String - Valid values are RETIRE/PURGE.
    Returns:
      String - If codevalues are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### getLogicallyDeletedCodeValues

    public String getLogicallyDeletedCodeValues(String userName, String password, String outputFormat, int codesetId)
    Returns the list of retired codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
    Returns:
      String - List of logically deleted codevalues in the form of JSON or XML String.
    Since:
      12.0

  - ### importCodesets

    public String importCodesets(String userName, String password, String outputFormat, int categoryId, String importHelper)
    Imports the codesets on the specified categoryId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the categoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `importHelper` - String
    Returns:
      String - If codesets are imported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'ImportHelper' JSON :
      {
      "filePath" : "",
      "filePathType": ""
      }

    Since:
      12.0

  - ### importCodeValues

    public String importCodeValues(String userName, String password, String outputFormat, int codesetId, String importHelper)
    Imports the codevalues on the specified codesetId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the codesetId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
      `importHelper` - String
    Returns:
      String - If codevalues are imported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'ImportHelper' JSON :
      {
      "filePath" : "",
      "filePathType": ""
      }

    Since:
      12.0

  - ### exportCodeValues

    public String exportCodeValues(String userName, String password, String outputFormat, int codesetId)
    Codevalues are exported to excel for the specified codesetId.
    All the codevalues of the specified codesetId are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE. Specifying the codesetId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codesetId` - int
    Returns:
      String - If codevalues are exported successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### exportCodesets

    public String exportCodesets(String userName, String password, String outputFormat, int categoryId, boolean includeSubCategories)
    Codesets are exported to excel for the specified categoryId. All the codesets of the specified categoryId are exported to excel, and sub category codesets are included only if the includeSubCategories flag is true.
    The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE. Specifying the categoryId and includeSubCategories flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `categoryId` - int
      `includeSubCategories` - boolean
    Returns:
      String - If codesets are exported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### exportAllCodesets

    public String exportAllCodesets(String userName, String password, String outputFormat)
    All the codesets present in enterprise codesets are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are exported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### restoreCodeValues

    public String restoreCodeValues(String userName, String password, String outputFormat, String codeValueIds)
    Retired codevalues can be restored for the specified codeValueIds. Specifying the codeValueIds is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `codeValueIds` - String
    Returns:
      String - If codevalues are restored successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### getAllRetiredCodesets

    public String getAllRetiredCodesets(String userName, String password, String outputFormat)
    Returns the list of all retired codesets present in enterprise codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String
    Since:
      12.0

  - ### assignCodeset

    public String assignCodeset(String userName, String password, String outputFormat, String nodeType, int nodeId, String codeset)
    Assigns the specified codeset object to the specified nodeType and nodeId. Specifying the codeset object having codesetId, nodeType and nodeId are are mandatory.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String
      `nodeId` - int
      `codeset` - String
    Returns:
      String - If codeset is assigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### assignCodesets

    public String assignCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId, String codesetIds, boolean unassignExisting)
    Assigns codesets of specified codeset ids to the specified nodeType and nodeId. Specifying the nodeType, nodeId, list of codeset ids and unassignExisting flag are mandatory.
    UnassignExisting flag can be either true or false. If it is true then existing codesets of specified nodeId are unassigned if any and the new codesets are assigned. If it is false then the new codesets are assigned without unassiging existing codesets of nodeId.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String
      `nodeId` - int
      `codesetIds` - String
      `unassignExisting` - boolean
    Returns:
      String - If codesets are assigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### unassignExistingCodesets

    public String unassignExistingCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId)
    Unassigns existing codesets for the specified nodeType of nodeId. Specifying the nodeType and nodeId are mandatory, based on these it unassigns the existing codesets of a node.
    NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String
      `nodeId` - int
    Returns:
      String - If codesets are unassigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### getAssignedCodesets

    public String getAssignedCodesets(String userName, String password, String outputFormat, String nodeType, int nodeId, int fillOptions)
    Returns the list of codeset objects for the specified nodeType and nodeId. The returned codeset objects contains all the details pertaining to codeset such as codeset name, codeset description, codeset status and category name in which codeset is present etc.. and also contains details of codeValue and codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.SMFillOptions`.
    Here fillOptions parameter takes value of either `com.ads.api.beans.common.APIConstants.SMFillOptions#CODE_VALUES` or `com.ads.api.beans.common.APIConstants.SMFillOptions#CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeValues and codeValue extended properties then fillOptions parameter value will be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 32+64=96 and so on.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String
      `nodeId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String List of codesets in the form of JSON or XML String.
    Since:
      12.0

  - ### getValidValues

    public String getValidValues(String userName, String password, String outputFormat, String nodeType, int nodeId, int fillOptions)
    Returns the list of codeValue objects for the specified nodeType and nodeId. The returned codeValue objects contains all the details pertaining to codeValue such as code name, code value, code description, codeset name in which codeValue is present etc..and also contains details of codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.SMFillOptions`.
    Here fillOptions parameter takes value of `com.ads.api.beans.common.APIConstants.SMFillOptions#CODE_VALUE_EXTENDED_PROPERTIES` whose value is 64. If fillOptions parameter value is passed as 64 then codeValue's extended properties are returned within the CodeValue object. If CodeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String
      `nodeId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - List of codevalues in the form of JSON or XML String.
    Since:
      12.0